// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#ifndef FILE_COMPASS_SEEN
#define FILE_COMPASS_SEEN

#include <iostream>

class seat
{
  enum direction
  {
    north = 0, east, south, west
  };

  direction _d;
  seat (const direction &d) : _d (d) {}
public:
  seat () : _d (north) {}

  // 0 <= offset_from_north < 4
  unsigned short offset_from_north () const
  {
    return _d;
  }

  seat operator+(short addend) const
  {
    return seat
           (static_cast<direction>
           ((static_cast<short>(_d) + addend) % 4));
  }

  short operator-(const seat &subtrahend) const
  {
    return static_cast<unsigned short>(_d) - static_cast<unsigned short>(subtrahend._d);
  }

  bool on_same_team (const seat &other) const
  {
    return ((other._d % 2)
            ==
            (this->_d % 2));
  }

  friend std::ostream & operator<<(std::ostream &o, const seat &s);
};

#endif  /* FILE_COMPASS_SEEN */
