#include <iostream>
#include "hand.hh"

void
hand::print (std::ostream &o,
             bool display_bidding_info) const
{
  for (hand::const_iterator card = this->begin ();
       card != this->end ();
       card++)
    {
      std::cout << *card;

      if (display_bidding_info)
        {
          std::cout << " ("
                    << card->get_HCP ()
                    << " HCP)";
        }

      std::cout << std::endl;
    }

  if (display_bidding_info)
    {
      std::cout << "Total HCP in hand: "
                << this->HCP ()
                << std::endl;

      std::cout << (this->is_balanced ()
                    ? ""
                    : "not ")
                << "balanced"
                << std::endl;

      std::cout << "Distribution:" << std::endl
                << "Clubs:    " << this->length (clubs)    << std::endl
                << "Diamonds: " << this->length (diamonds) << std::endl
                << "Hearts:   " << this->length (hearts)   << std::endl
                << "Spades:   " << this->length (spades)   << std::endl;

    }
}
